#include <linux/types.h>
#include <linux/slab.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/tty.h>

#include "utils.h"

bool signature_check(const u8* calc_sig, const u8* cmp_sig, size_t max_size)
{
    size_t i  = 0;
    for (; i<max_size; ++i) {
        if (calc_sig[i]!= cmp_sig[i]) {
            return false;
        }
    }
    // lic_warning("signature_check success");
    return true;
}


void dump_bytes(char *header, const unsigned char *bytes, int size)
{
    int i = 0;
    int line;
    u8 buffer[8] = {0};
    line = size / 8;
    lic_info("%s %d\n", header, size);
    for (i = 0; i < line; ++i) {
        lic_info("%02x %02x %02x %02x %02x %02x %02x %02x\n",
                 bytes[i*8+0], bytes[i*8+1], bytes[i*8+2], bytes[i*8+3],
                 bytes[i*8+4], bytes[i*8+5], bytes[i*8+6], bytes[i*8+7]);
    }

    if (size > line * 8) {
        memcpy(buffer, bytes + (line*8), size - line*8);
        lic_info("%02x %02x %02x %02x %02x %02x %02x %02x\n",
                 buffer[0], buffer[1], buffer[2], buffer[3],
                 buffer[4], buffer[5], buffer[6], buffer[7]);
    }
}

void print_string(char *string)
{
    struct tty_struct *tty;
    tty = get_current_tty();
    if(tty != NULL) {
        (tty->driver->ops->write) (tty, string, strlen(string));
        (tty->driver->ops->write) (tty, "\015\012", 2);
    } else
        lic_err("tty equals to zero");
}
